/**
*  inheritance(+ClassId,?SuperClassId)
*  succeeds iff Arg1 inherited by Arg2, and Arg1 is not an interface, extern or anonymous
*/
inheritance(ClassId,SuperClassId) :-
    implementsT(ClassId, SuperClassId),
    interfaceT(ClassId),
    not(externT(ClassId)),
  	classT(ClassId,_,ClassName,_),
    not(string_concat('ANONYMOUS',_,ClassName)).

%If both are classes, everything is fine (just check for extends)
inheritance(ClassId,SuperClassId) :-
    extendsT(ClassId, SuperClassId),
    not(interfaceT(ClassId)),
  	classT(ClassId,_,ClassName,_),
    not(externT(ClassId)),
    not(string_concat('ANONYMOUS',_,ClassName)).


inheritance(ClassId,SuperClassId) :-
    extendsT(ClassId, SuperClassId),
    interfaceT(ClassId),
  	not(externT(ClassId)),
    interfaceT(SuperClassId).
    	

    
    
	