/**
* implements_interface(?ClassID, ?InterfaceID)
*
* Checks if class (also interface is possible) implements (direct or indirect) the given interface.
*/
implements_interface(ClassID, InterfaceID) :-
    not(interfaceT(ClassID)),
    interfaceT(InterfaceID),
    implementsT(ClassID, InterfaceID).

implements_interface(InterfaceID1, InterfaceID2) :-
    interfaceT(InterfaceID1),
    interfaceT(InterfaceID2),
    extendsT(InterfaceID1, InterfaceID2).

implements_interface(ClassID, InterfaceID) :-
    not(interfaceT(ClassID)),
    interfaceT(InterfaceID),
    implementsT(ClassID, MiddleInterfaceID),
    implements_interface(MiddleInterfaceID, InterfaceID).

implements_interface(InterfaceID1, InterfaceID2) :-
    interfaceT(InterfaceID1),
    interfaceT(InterfaceID2),
    extendsT(InterfaceID1, MiddleInterfaceID),
    implements_interface(MiddleInterfaceID, InterfaceID2).

