:- multifile termmetric/4.
:- multifile query_description/3.

query_description(termsurprise,termmetric, 'Returns two list with the terms and tf x idf suprisingness').

/** 
*  termmetric_(termfrequency,+Scope, -ContextID , -TermFrequencies)
*  Returns the term frequencies for the given scope, scope can be packageT,classT,methodDef
*  The returned list contains also if a term is introduced in this context.
**/
termmetric(termsurprise,Scope, ContextID , TermFrequencies) :-
   once(term_metrics:metric_precondition),
   ast_node_type_value(ContextID,Scope), 
   not(externT(ContextID)), 
   term_surprise_query__(ContextID, TermFrequencies).    

/**
* term_frequency_query__(+Context, -TermFrequencies)
* Returns all term frequencies for the given context Id. 
* Additionally this contains if a term is introduced in this context.
**/   
term_surprise_query__(Context, TermSurprise) :-
    findall(
    	[Term,TFIDF,IsIntroducedInContext], 
    	 (cached_term_metrics_tfidf(Context,Term,TFIDF),
    	  is_term_introduced(Context,Term, IsIntroducedInContext)), 
    	TermSurprise
    ).
    

/**
* surprising_terms_for_context(+Context,-TermSuprise)
* Arg2 is a list of terms for context Arg1, each having surprise value greater zero.
*/
surprising_terms_for_context(Context,TermSurpise) :- 
      findall( Term, 
      		   (cached_term_metrics_tfidf(Context,Term,Value),Value>0.0),
      		   TermSurpise).
      		       
/**
* surprise_of_context(+Context,-ContextSurprise)
* Arg2 is the sum of all tfidf values in context Arg1
*/
surprise_of_context(Context,ContextSurprise) :-
      findall( Value, 
      		   (cached_term_metrics_tfidf(Context,_,Value),Value>0.0),
      		   TermSurprise),
      sumlist(TermSurprise,ContextSurprise).		   
      


