/**
* number_of_method_calls(+Method,?NoMC)
* succeeds iff Arg2 is the number of calls on method with id Arg1
*/
number_of_method_calls(Method,NoMC):-
        count(Call, ri_callT_ref(Method,Call),NoMC).
        
/**
* number_of_method_calls_including_children(+Method,?NoMC)
* succeeds iff Arg2 is the number of calls on method with id Arg1 and all calls to methods in subtypes with the same signature
*/
number_of_method_calls_including_children(SuperMethod,NoMC):-
          number_of_method_calls(SuperMethod,NoDC),
          findall(NoMC, 
          			( method_is_redefined__(SuperMethod,MethodID),
          			  number_of_method_calls(MethodID,NoMC)), ListOfCounts),
         sumlist(ListOfCounts,SumCounts),
         NoMC is SumCounts+NoDC. 		  	  
          
%%% +,?
method_is_redefined__(SuperMethodID,MethodID) :-
    methodDef(SuperMethodID, SuperClassID, _, _, _, _, _),
    not(is_static(SuperMethodID)),
    real_subtype(ClassID,SuperClassID),
    type_contains_method(ClassID,MethodID),
    not(is_static(MethodID)),
    same_signature(MethodID, SuperMethodID),
    can_access_method(ClassID, SuperMethodID).
    
    