:- multifile query_description/3.
:- multifile metric_/3.
:- multifile metric_attributes/2.

query_description(distance, metric, 'distance from the main line').
metric_attributes(distance, float(range(0, 1), defaultthresholds(0, 0.4))).
          
/** *****************************************************************
  * distance(+PackageId, ?Distance)
  *
  * Returns the distance (as defined by Robert C Martin) for the
  * package PackageId/PackageName.
  *
  * ALTERNATIVE (not implemented):
  * If the package has no couplings at all it could return the
  * Abstractness value. So high abstractness values would result
  * in high distance values (which are considered bad). The rationale
  * for this alternative is that a completely unconnected package is
  * probably less useful the more abstract it is.
  */
metric_(distance, PackageID, Distance) :-
    internal_package(PackageID),
    metric(abstractness, PackageID, Abstract),
    metric(instability, PackageID, Instability),
    Distance is abs(Abstract + Instability - 1).